<?xml version="1.0"?>

<!--
      All of the messy setup to load the gazebo world and spawn Raven.
-->

<launch>
  <arg name="gui" default="true"/>
  <!-- terminate launch when gzclient exits-->
  <arg name="gui_required" value="true"/>
  <arg name="paused" default="true"/>
  <!-- This is the recommended naming convention when setting up gazebo for a robot. -->
  <arg name="world_name" default="$(find raven_gazebo)/worlds/raven.world"/>

  <include file="$(find gazebo_ros)/launch/empty_world.launch">
    <arg name="world_name" value="$(arg world_name)"/>
    <!-- This will be needed when we use any ds_sensors, thanks to Ian's hack. -->
    <arg name="extra_gazebo_args" value="-s libdsros_sensors.so"/>
    <arg name="paused" value="$(arg paused)"/>
    <arg name="use_sim_time" value="true"/>
    <arg name="gui" value="$(arg gui)"/>
    <arg name="headless" value="false"/>
    <arg name="debug" value="false"/>
    <arg name="verbose" value="true"/>
    <arg name="gui_required" value="$(arg gui_required)"/>
  </include>

  <!-- TODO: Switch between these based on command line arguments -->
  <!-- Typically these would be specified in gazebo.world since they're
       part of the environment, but I wanted to be able to switch between
       them with launch arguments
       (I'm not sure that the bop_panel works in gazebo.world, but the other definitely do). -->

  <node name="spawn_bop_panel" pkg="gazebo_ros" type="spawn_model"
        args="-file $(find uuv_gazebo_worlds)/models/bop_panel/model.sdf -sdf -model bop_panel -x 15 -y -10 -z -94.9 ">
  </node>
  <node name="spawn_turbine_lander" pkg="gazebo_ros" type="spawn_model"
        args="-file $(find raven_gazebo)/models/turbine_lander/model.sdf -sdf -model turbine_lander -x 35 -y 20 -z -94.9 ">
  </node>
  <!--
  <node name="spawn_amp_lander" pkg="gazebo_ros" type="spawn_model"
        args="-file $(find raven_gazebo)/models/3g_amp_lander/model.sdf -sdf -model amp_lander -x 35 -y 20 -z -94.9 ">
  </node>
  -->

  <!-- Set robot initial position on the parameter server so the teleporting
       plugin knows where to start the robot.
       NB: These are in the world_gazebo frame, not the world frame. -->
  <arg name="robot_x" default="28"/>
  <arg name="robot_y" default="20"/>
  <arg name="robot_z" default="-92.5"/>
  <arg name="robot_yaw" default="-0.2"/>

  <node name="urdf_spawner" pkg="gazebo_ros" type="spawn_model"
        respawn="false" output="screen"
        args="-urdf -model raven -param robot_description -x $(arg robot_x) -y $(arg robot_y) -z $(arg robot_z) -R 3.14 -Y $(arg robot_yaw)"/>

 </launch>
